package com.bonus.system.api.factory;

import com.bonus.common.core.web.domain.AjaxResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;
import com.bonus.common.core.domain.R;
import com.bonus.system.api.RemoteFileService;
import com.bonus.system.api.domain.SysFile;

/**
 * 文件服务降级处理
 * 
 * @author bonus
 */
@Component
public class RemoteFileFallbackFactory implements FallbackFactory<RemoteFileService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteFileFallbackFactory.class);

    @Override
    public RemoteFileService create(Throwable throwable)
    {
        log.error("文件服务调用失败:{}", throwable.getMessage());
        return new RemoteFileService()
        {
            @Override
            public AjaxResult upload(MultipartFile file)
            {
                return AjaxResult.error("单上传文件失败:" + throwable.getMessage());
            }

            @Override
            public AjaxResult uploadFile(MultipartFile[] files) {
                return AjaxResult.error("多上传文件失败:" + throwable.getMessage());
            }

            @Override
            public AjaxResult deleteFile(String objectKey) {
                return AjaxResult.error("删除文件失败:" + throwable.getMessage());
            }
        };
    }
}
